package code;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;

import javax.net.ssl.HttpsURLConnection;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

public class Authentication implements HttpHandler {
	
	private static KeyCloak kcs;
	private static String remoteHost;
	private static String localHost;
	private static String token;
	
	
	public Authentication() throws MalformedURLException, IOException {
		String path = "../webapp/public/";
		kcs = new KeyCloak(path+"keycloak.json", path+"params.json");
		remoteHost = kcs.authServer();
		localHost = "http://localhost:3000";
		token = "";
	}

	@Override
	public void handle(HttpExchange exchange) throws IOException {
		URI requestUri = exchange.getRequestURI();
		String response; 
		String requestMethod = exchange.getRequestMethod();
		
		if(requestMethod.compareTo("POST")==0 || requestMethod.compareTo("post")==0) {
			URI tokenrq = URI.create(kcs.tokenRQ());
			response = postRemote(tokenrq, exchange.getRequestBody(), kcs.extraBody());
			token = response;
			exchange.sendResponseHeaders(200, response.getBytes().length);
			OutputStream os = exchange.getResponseBody();
			os.write(response.getBytes());
			os.close();
		}
		else {
			 Helper.methodNotAllowed(exchange);
		}
		
	}
	
	private String postRemote(URI pageUri, InputStream httpBody, String extraBody) throws IOException {
		String url = remoteHost + pageUri.toString();
		InputStream is;
        InputStreamReader isr;
        BufferedReader br;
        String body = extraBody;
        String response = "";
        int i;
        char c;
        while((i=httpBody.read()) != -1) {
        	c = (char)i;
        	body += c;
        }
        httpBody.close();
        URL myUrl = new URL(url);
        SSLUtilities.trustAllHttpsCertificates();
        SSLUtilities.trustAllHostnames();
        HttpsURLConnection conn = (HttpsURLConnection)myUrl.openConnection();

        conn.setReadTimeout(7000);
        conn.setConnectTimeout(7000);
        conn.setRequestMethod("POST");
        conn.setDoOutput(true);
        conn.setDoInput(true);

        OutputStream outputStream = conn.getOutputStream();
        outputStream.write(body.getBytes("UTF-8"));
        outputStream.close();

        String inputLine;
        is = conn.getInputStream();
        isr = new InputStreamReader(is);
        br = new BufferedReader(isr);
        while ((inputLine = br.readLine()) != null) {
        	response += inputLine;
        }

        br.close();
        String answer = response.replace(remoteHost,localHost);
        return answer;

	}

}
